-- WLAN example: reads a test file from www.luaplayer.org
-- and provides a very simple webserver on the PSP

dofile("netlib.lua") -- netlib

pc_ip = "192.168.0.3"
pc_port = 2007

white = Color.new(255, 255, 255)
red = Color.new(255, 128, 128)
black = Color.new(0, 0, 0)
offscreen = Image.createEmpty(480, 272)
offscreen:clear(Color.new(0, 0, 0))

--background = Image.createEmpty(480, 272)
--background = Image.load("gauge.png")

y = 0
x = 0

tx = 0
ty = 0

rpm = "0"
spd = "0"
gear = "0"
time = "0"

rpmoffx = 115
rpmoffy = 158

spdoffx = 365
spdoffy = 158

gearoffx = 230
gearoffy = 40

timeoffx = 220
timeoffy = 250

min = ""
sec = ""
msec = ""

--rad = 0.017453292519943295769236907684886
--std = 1.1956521739130434782608695652174
--rtd = 31.666666666666666666666666666667

    buttons = {}
    buttons.analogx = 0
    buttons.analogy = 0
    buttons.cross = 0
    buttons.circle = 0
    buttons.triangle = 0
    buttons.square = 0
    buttons.up = 0
    buttons.down = 0
    buttons.left = 0
    buttons.right = 0
    buttons.l = 0
    buttons.r = 0
    buttons.select = 0
    buttons.start = 0

function render()

	screen:blit(0, 0, offscreen)
	--screen:blit(0, 0, background, 0, 0, background:width(), background:height(), true)
	--screen:print(gearoffx, gearoffy, gear, white)
	--screen:print(timeoffx, timeoffy, time, white)
		--if tonumber(rpm)<350 then 
		--	rpm = 350
		--end
	--tx = rpmoffx + math.sin((((tonumber(rpm)*0.001)*rtd)-128.375)*rad) * 100
	--ty = rpmoffy - math.cos((((tonumber(rpm)*0.001)*rtd)-128.375)*rad) * 100
        --screen:drawLine(rpmoffx, rpmoffy, tx, ty, red)
	--tx = spdoffx + math.sin((((tonumber(spd)*std))-135.888)*rad) * 100
	--ty = spdoffy - math.cos((((tonumber(spd)*std))-135.888)*rad) * 100
        --screen:drawLine(spdoffx, spdoffy, tx, ty, red)
	screen.waitVblankStart()
	screen.flip()

end

function graphicsPrint(text)
	for i = 1, string.len(text) do
		char = string.sub(text, i, i)
		if char == "\n" then
			y = y + 8
			x = 0
		elseif char ~= "\r" then
			offscreen:print(x, y, char, white)
			x = x + 8
		end
	end
	render()
end

function graphicsPrintln(text)
	graphicsPrint(text .. "\n")
end

-- init WLAN and choose connection config
Wlan.init()
configs = Wlan.getConnectionConfigs()
graphicsPrintln("available connections:")
graphicsPrintln("")
for key, value in ipairs(configs) do
	graphicsPrintln(key .. ": " .. value)
end
graphicsPrintln("")
graphicsPrintln("using first connection...")
Wlan.useConnectionConfig(1)

-- start connection and wait until it is connected
graphicsPrintln("waiting for WLAN init and determining IP address...")
while true do
	ipAddress = Wlan.getIPAddress()
	if ipAddress then break end
	System.sleep(100)
end
graphicsPrintln("the PSP IP address is: " .. ipAddress)
graphicsPrintln("")

graphicsPrintln("connecting to "..pc_ip.."...")
udpSocket = Socket.udpConnect(pc_ip, 2007)
graphicsPrintln("Socket opened and ready!")

while true do

	buffer = udpSocket:recv()
	if string.len(buffer) > 0 then 
		--RPM 0000 SPD 0000 GEAR 00 TIME 000000
		--rpm = string.sub(buffer, 1, 4)
		--spd = string.sub(buffer, 5, 8)
		--gear = string.sub(buffer, 9, 10)
		--time = string.sub(buffer, 11, 16)
		--min = string.sub(time, 1, 2)
		--sec = string.sub(time, 3, 4)
		--msec = string.sub(time, 5, 6)
		--time = min..":"..sec..":"..msec
	end
	
	-- check for buttons
	pad = Controls.read()

	--if pad:analogX() ~= buttons.analogx then
	--	buttons.analogx = pad:analogX() + 128
	--	buttons.analogy = pad:analogY() + 128
	--	bytesSent = udpSocket:udpSend(string.format("%03d",buttons.analogx)..string.format("%03d",buttons.analogy).."analog!")
	--end
	--if pad:analogY() ~= buttons.analogy then
	--	buttons.analogx = pad:analogX() + 128
	--	buttons.analogy = pad:analogY() + 128
	--	bytesSent = udpSocket:udpSend(string.format("%03d",buttons.analogx)..string.format("%03d",buttons.analogy).."analog!")
	--end
	if pad:up() then
		if buttons.up == 0 then
			bytesSent = udpSocket:udpSend("up1!")
			buttons.up = 1
		end
	else
		if buttons.up == 1 then
			bytesSent = udpSocket:udpSend("up0!")
			buttons.up = 0
		end
	end

	if pad:down() then
		if buttons.down == 0 then
			bytesSent = udpSocket:udpSend("down1!")
			buttons.down = 1
		end
	else
		if buttons.down == 1 then
			bytesSent = udpSocket:udpSend("down0!")
			buttons.down = 0
		end
	end

	if pad:left() then
		if buttons.left == 0 then
			bytesSent = udpSocket:udpSend("left1!")
			buttons.left = 1
		end
	else
		if buttons.left == 1 then
			bytesSent = udpSocket:udpSend("left0!")
			buttons.left = 0
		end
	end

	if pad:right() then
		if buttons.right == 0 then
			bytesSent = udpSocket:udpSend("right1!")
			buttons.right = 1
		end
	else
		if buttons.right == 1 then
			bytesSent = udpSocket:udpSend("right0!")
			buttons.right = 0
		end
	end

	if pad:circle() then
		if buttons.circle == 0 then
			bytesSent = udpSocket:udpSend("circle1!")
			buttons.circle = 1
		end
	else
		if buttons.circle == 1 then
			bytesSent = udpSocket:udpSend("circle0!")
			buttons.circle = 0
		end
	end

	if pad:triangle() then
		if buttons.triangle == 0 then
			bytesSent = udpSocket:udpSend("triangle1!")
			buttons.triangle = 1
		end
	else
		if buttons.triangle == 1 then
			bytesSent = udpSocket:udpSend("triangle0!")
			buttons.triangle = 0
		end
	end

	if pad:square() then
		if buttons.square == 0 then
			bytesSent = udpSocket:udpSend("square1!")
			buttons.square = 1
		end
	else
		if buttons.square == 1 then
			bytesSent = udpSocket:udpSend("square0!")
			buttons.square = 0
		end
	end

	if pad:cross() then
		if buttons.cross == 0 then
			bytesSent = udpSocket:udpSend("cross1!")
			buttons.cross = 1
		end
	else
		if buttons.cross == 1 then
			bytesSent = udpSocket:udpSend("cross0!")
			buttons.cross = 0
		end
	end

	if pad:l() then
		if buttons.l == 0 then
			bytesSent = udpSocket:udpSend("l1!")
			buttons.l = 1
		end
	else
		if buttons.l == 1 then
			bytesSent = udpSocket:udpSend("l0!")
			buttons.l = 0
		end
	end

	if pad:r() then
		if buttons.r == 0 then
			bytesSent = udpSocket:udpSend("r1!")
			buttons.r = 1
		end
	else
		if buttons.r == 1 then
			bytesSent = udpSocket:udpSend("r0!")
			buttons.r = 0
		end
	end

	if pad:select() then
		if buttons.select == 0 then
			bytesSent = udpSocket:udpSend("select1!")
			buttons.select = 1
		end
	else
		if buttons.select == 1 then
			bytesSent = udpSocket:udpSend("select0!")
			buttons.select = 0
		end
	end


	if pad:start() then
		if buttons.start == 0 then
			bytesSent = udpSocket:udpSend("start1!")
			buttons.start = 1
		end
	else
		if buttons.start == 1 then
			bytesSent = udpSocket:udpSend("start0!")
			buttons.start = 0
		end
	end

render()
end
Wlan.term()
